<script lang="ts">
import type {
  ControlElement,
  JsonFormsRendererRegistryEntry,
} from "@jsonforms/core";
import type {
  RendererProps,
} from "@jsonforms/vue";

import {
  and,
  formatIs,
  isStringControl,
  rankWith,
} from "@jsonforms/core";
import {
  rendererProps,
  useJsonFormsControl,
} from "@jsonforms/vue";
import { ControlWrapper, DisabledIconFocus, useVuetifyControl } from "@jsonforms/vue-vuetify";
import { defineComponent } from "vue";
import { VHover, VTextarea } from "vuetify/components";

const controlRenderer = defineComponent({
  name: "MultiStringControlRenderer",
  components: {
    ControlWrapper,
    VHover,
    VTextarea,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    return useVuetifyControl(
      useJsonFormsControl(props),
      value => value || undefined,
      300,
    );
  },
});

export default controlRenderer;

export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(2, and(isStringControl, formatIs("multi"))),
};
</script>

<template>
  <ControlWrapper
    v-bind="controlWrapper"
    :styles="styles"
    :isFocused="isFocused"
    :appliedOptions="appliedOptions"
  >
    <VHover v-slot="{ isHovering }">
      <VTextarea
        :id="`${control.id}-input`"
        v-disabled-icon-focus
        :class="styles.control.input"
        :disabled="!control.enabled"
        :autofocus="appliedOptions.focus"
        :placeholder="appliedOptions.placeholder"
        :label="computedLabel"
        :hint="control.description"
        :persistent-hint="persistentHint()"
        :required="control.required"
        :error-messages="control.errors"
        :model-value="control.data"
        :maxlength="
          appliedOptions.restrict ? control.schema.maxLength : undefined
        "
        :size="
          appliedOptions.trim && control.schema.maxLength !== undefined
            ? control.schema.maxLength
            : undefined
        "
        :clearable="isHovering"
        multi-line
        v-bind="vuetifyProps('v-textarea')"
        @update:model-value="onChange"
        @focus="handleFocus"
        @blur="handleBlur"
      />
    </VHover>
  </ControlWrapper>
</template>
